/*
  Copyrights Fares Belhadj - 2008
  amsi@ai.univ-paris8.fr
*/

#include <PA9.h>
#include <math.h>
#include <stdlib.h>
#include <assert.h>

#define SW 256
#define SH 192
#define SS 20
#define G 200.0

#define MIN(a, b) (((a) > (b)) ? (b) : (a))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

/* a n'est pas du travail ! */
#define dt 0.01666666666666666666


typedef struct mobile_t   mobile_t;
typedef struct vector2f_t vector2f_t;
typedef struct vector2f_t point2f_t;

struct vector2f_t {
  float x, y;
};

struct mobile_t {
  u8 sprite;
  point2f_t p;
  vector2f_t v, a;
  s16 w, h;
  float ta, tl;
  int ax, ay, lx, ly;
};

unsigned short sprite0_Pal[17] __attribute__ ((aligned (4))) = {
  0, 
  PA_RGB(31,  0,  0), PA_RGB( 0, 31,  0), PA_RGB( 0,  0, 31), PA_RGB(31, 31,  0), 
  PA_RGB(31,  0, 31), PA_RGB( 0, 31, 31), PA_RGB(31, 31, 31), PA_RGB(31, 16, 16), 
  PA_RGB(16, 31, 16), PA_RGB(16, 16, 31), PA_RGB(31, 31, 16), PA_RGB(31, 16, 31), 
  PA_RGB(16, 31, 31), PA_RGB(16,  0,  0), PA_RGB( 0, 16,  0), PA_RGB( 0,  0, 16)
};

u8 * makeSprite(int s) {
  int i, c;
  int x, y;
  u8 * t;
  t = malloc(1024 * sizeof * t);
  assert(t);
  switch(s) {
  case 0:
    for(i = 0; i < 1024; i++)
      t[i] = 1 + (i>>6);
    return t;
  case 1:
    for(i = 0; i < 1024; i++) {
      c = i >> 6;
      x = ((c & 3) << 3) + (i & 7);
      t[i] = 1 + (x & 15);
    }
    return t;
  case 2:
    for(i = 0; i < 1024; i++) {
      c = i >> 6;
      y = ((c >> 2) << 3) + ((i >> 3) & 7);
      t[i] = 1 + (y & 15);
    }
    return t;
  default:
    for(i = 0; i < 1024; i++) {
      c = i >> 6;
      x = ((c & 3) << 3) + (i & 7) - 16;
      y = ((c >> 2) << 3) + ((i >> 3) & 7) - 16;
      t[i] = x * x + y * y <= 16 * 16 ? 1 : 0;
    }
    return t;
  }
}

void ricochet(mobile_t * m) {
  if(m->p.x < 0) {
    m->p.x = 0;
    if(m->v.x < 0.0) m->v.x = - m->v.x;
  } else if(m->p.x + m->w >= SW) {
    m->p.x = SW - 1 - m->w;
    if(m->v.x > 0.0) m->v.x = - m->v.x;
  }
  if(m->p.y < 0) {
    m->p.y = 0;
    if(m->v.y < 0.0) m->v.y = - m->v.y;
  } else if(m->p.y + m->h >= (SH<<1) + SS) {
    m->p.y = (SH<<1) + SS - 1 - m->h;
    if(m->v.y > 0.0) m->v.y = - m->v.y;
  }
}

void frottements(mobile_t * m) {
  const float k = 0.00005;
  float d, a;
  d  = sqrt(m->v.x * m->v.x + m->v.y * m->v.y);
  a  = atan2(m->v.y, m->v.x);
  d = d - k * d * d; 
  d = MAX(d, 0);
  m->v.x = d * cos(a);
  m->v.y = d * sin(a);
}

int main(int argc, char ** argv) {
  float t = 0;
  u8 * s;
  mobile_t m = {0, // spriteId
		{SW >> 1, SH}, // position 
		{0, -50}, // vitesse_0
		{0, G},  // acceleration
		32, 32 // dimensions
  };
  PA_Init();
  PA_InitVBL();

  PA_DualLoadSpritePal(0, (void *)sprite0_Pal);
  PA_DualCreateSprite(0, s = makeSprite(0), OBJ_SIZE_32X32, 1, 0, -32, -32); free(s);
  PA_DualCreateSprite(1, s = makeSprite(1), OBJ_SIZE_32X32, 1, 0, -32, -32); free(s);
  PA_DualCreateSprite(2, s = makeSprite(2), OBJ_SIZE_32X32, 1, 0, -32, -32); free(s);
  PA_DualCreateSprite(3, s = makeSprite(3), OBJ_SIZE_32X32, 1, 0, -32, -32); free(s);

  PA_SetScreenSpace (SS);
  PA_DualSetSpriteXY(m.sprite, m.p.x, m.p.y);
  while (1) {
    if(Pad.Newpress.A) m.sprite = (m.sprite + 1) % 4;
    if(Stylus.Newpress) {
      m.ax = m.p.x = Stylus.X - (m.w >> 1);
      m.ay = m.p.y = SH + SS + Stylus.Y - (m.h >> 1);
      m.ta = t;
    } else if(Stylus.Held) {
      m.p.x = Stylus.X - (m.w >> 1);
      m.p.y = SH + SS + Stylus.Y - (m.h >> 1);
    } else if(Stylus.Released) {
      m.lx = m.p.x = Stylus.X - (m.w >> 1);
      m.ly = m.p.y = SH + SS + Stylus.Y - (m.h >> 1);
      m.tl = t;
      m.v.x = (m.lx - m.ax) / (m.tl - m.ta);
      m.v.y = (m.ly - m.ay) / (m.tl - m.ta);
    } else {
      m.v.x += m.a.x * dt;
      m.v.y += m.a.y * dt;
      frottements(&m);
      m.p.x += m.v.x * dt;
      m.p.y += m.v.y * dt;
      ricochet(&m);
    }
    PA_DualSetSpriteXY(m.sprite, m.p.x, m.p.y);
    t += dt;
    PA_WaitForVBL();
  }
  return 0;
}

